From 95208218cac6a319d82f6c711e640cc8b3022080 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 05 2020 07:15:31 +0000
Subject: [PATCH 1267/2232] Add interned vec helpers


---

diff --git a/gen/build/src/cfg.rs b/gen/build/src/cfg.rs
index 880224a..00f9535 100644
--- a/gen/build/src/cfg.rs
+++ b/gen/build/src/cfg.rs
@@ -91,13 +91,13 @@ pub use self::r#impl::Cfg::CFG;
 #[cfg(not(doc))]
 mod r#impl {
     use crate::intern::{intern, InternedString};
+    use crate::vec::{self, InternedVec as _};
     use lazy_static::lazy_static;
     use std::cell::RefCell;
     use std::collections::HashMap;
     use std::fmt::{self, Debug};
     use std::marker::PhantomData;
     use std::ops::{Deref, DerefMut};
-    use std::path::Path;
     use std::sync::{PoisonError, RwLock};
 
     struct CurrentCfg {
@@ -151,25 +151,9 @@ mod r#impl {
         fn current() -> super::Cfg<'a> {
             let current = CURRENT.read().unwrap_or_else(PoisonError::into_inner);
             let include_prefix = current.include_prefix.str();
-            let exported_header_dirs = current
-                .exported_header_dirs
-                .iter()
-                .copied()
-                .map(InternedString::str)
-                .map(Path::new)
-                .collect();
-            let exported_header_prefixes = current
-                .exported_header_prefixes
-                .iter()
-                .copied()
-                .map(InternedString::str)
-                .collect();
-            let exported_header_links = current
-                .exported_header_links
-                .iter()
-                .copied()
-                .map(InternedString::str)
-                .collect();
+            let exported_header_dirs = current.exported_header_dirs.vec();
+            let exported_header_prefixes = current.exported_header_prefixes.vec();
+            let exported_header_links = current.exported_header_links.vec();
             super::Cfg {
                 include_prefix,
                 exported_header_dirs,
@@ -237,24 +221,9 @@ mod r#impl {
             if let Cfg::Mut(cfg) = self {
                 let mut current = CURRENT.write().unwrap_or_else(PoisonError::into_inner);
                 current.include_prefix = intern(cfg.include_prefix);
-                current.exported_header_dirs = cfg
-                    .exported_header_dirs
-                    .iter()
-                    .copied()
-                    .map(|path| intern(&path.to_string_lossy()))
-                    .collect();
-                current.exported_header_prefixes = cfg
-                    .exported_header_prefixes
-                    .iter()
-                    .copied()
-                    .map(intern)
-                    .collect();
-                current.exported_header_links = cfg
-                    .exported_header_links
-                    .iter()
-                    .copied()
-                    .map(intern)
-                    .collect();
+                current.exported_header_dirs = vec::intern(&cfg.exported_header_dirs);
+                current.exported_header_prefixes = vec::intern(&cfg.exported_header_prefixes);
+                current.exported_header_links = vec::intern(&cfg.exported_header_links);
             } else {
                 CONST_DEREFS.with(|derefs| derefs.borrow_mut().remove(&self.handle()));
             }
diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index b4a455a..ef34d43 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -62,6 +62,7 @@ mod out;
 mod paths;
 mod syntax;
 mod target;
+mod vec;
 
 use crate::error::{Error, Result};
 use crate::gen::error::report;
diff --git a/gen/build/src/vec.rs b/gen/build/src/vec.rs
new file mode 100644
index 0000000..ac9235e
--- /dev/null
+++ b/gen/build/src/vec.rs
@@ -0,0 +1,50 @@
+use crate::intern::{self, InternedString};
+use std::path::Path;
+
+pub trait InternedVec<T>
+where
+    T: ?Sized,
+{
+    fn vec(&self) -> Vec<&'static T>;
+}
+
+impl<T> InternedVec<T> for Vec<InternedString>
+where
+    T: ?Sized + Element,
+{
+    fn vec(&self) -> Vec<&'static T> {
+        self.iter().copied().map(Element::unintern).collect()
+    }
+}
+
+pub fn intern<T>(elements: &[&T]) -> Vec<InternedString>
+where
+    T: ?Sized + Element,
+{
+    elements.iter().copied().map(Element::intern).collect()
+}
+
+pub trait Element {
+    fn intern(&self) -> InternedString;
+    fn unintern(_: InternedString) -> &'static Self;
+}
+
+impl Element for str {
+    fn intern(&self) -> InternedString {
+        intern::intern(self)
+    }
+
+    fn unintern(interned: InternedString) -> &'static Self {
+        interned.str()
+    }
+}
+
+impl Element for Path {
+    fn intern(&self) -> InternedString {
+        intern::intern(&self.to_string_lossy())
+    }
+
+    fn unintern(interned: InternedString) -> &'static Self {
+        Path::new(interned.str())
+    }
+}

